/*****************************************************************************\
* LiveIPAddress: Retrieves your Live IP Address (using the showmyip.com (R)   *
* engine) and displays it on Firefox's status bar.                            *
*                                                                             *
* Version 1.11                                              Date: 08 Jan 2006 *
* In the currect version the following features have been added:              *
*    1. By single-clicking on the IP address field in Firefox's status bar,   *
*       the extension checks for changes in the IP value.                     *
*    2. Under the Tool menu-item, an entry called Live IP Address has been    *
*       added which lets the user specify the frequency (in minutes) where    *
*       IP will be checked for changes.                                       *
*    3. Added locales: French, German and Greek                               *
*                                                                             *
* Copyright 2006 Anastasios Monachos                                          *
* Email: anastasiosm@hotmail.com                                              *
*                                                                             *
* Inspired by the Public IP - Firefox Extention created by Daniel Wood        *
* (http://www.maleman876.com/) - as I would prefare showing my live IP        *
* address permanently in the status bar.                                      *
*                                                                             *
* This program is free software; you can redistribute it and/or modify it     *
* under the terms of the GNU General Public License as published by the Free  *
* Software Foundation; either version 2 of the License, or (at your option)   *
* any later version.                                                          *
*                                                                             *
* This program is distributed in the hope that it will be useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTIBLITY or        *
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for   *
* more details.                                                               *
*                                                                             *
* You should have received a copy of the GNU General Public License along     *
* with this program; if not, write to the Free Software Foundation, Inc.,     *
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.                    *
*                                                                             *
\*****************************************************************************/

/*Set here the default value to check for IP changes (in milliseconds) */
var refreshEveryMilliSeconds = 1000000;

/*Get user's value, check for valid input and if OK call convertMinutesToMilliSeconds */
function setRefreshRateDialog()
{
	var input = prompt('Please enter a value in minutes to set how often you want to check for IP changes.\nValid values in range 17 - 1422.')
	if (input>=17 && input<=1422)
	{
		convertMinutesToMilliSeconds(input)
	}
	else if (input<17 || input>1422)
	{
		alert('Invalid input.  Please try again.');
		refreshEveryMilliSeconds = 1000000;
		updateliveipaddress();
	}
}

/*As the name of the function tells, this converts user's input refresh time from minutes to milliseconds,
  and the passes the call to the updateliveipaddress function.*/
function convertMinutesToMilliSeconds(valueFromsetRefreshRateDialog)
{
	refreshEveryMilliSeconds = valueFromsetRefreshRateDialog * 60 * 1000;
	updateliveipaddress();
}

function makeRequest(url, parameters)
{
	http_request = false;
	http_request = new XMLHttpRequest();
	if (http_request.overrideMimeType)
	{
		http_request.overrideMimeType('text/xml');
	}
	if (!http_request)
	{
		
    var linkstatusmessage =
    alert(document.getElementById('liveipaddress-strings').getString("ImpossibleCreation"));
		return false;
	}
	http_request.onreadystatechange = alertContents;
	http_request.open('GET', url + parameters, true);
	http_request.send(null);
}

function alertContents()
{
	if (http_request.readyState == 4)
	{
		if (http_request.status == 200)
		{
			var xmlobject = http_request.responseXML;
			var root = xmlobject.getElementsByTagName('ip_address')[0];
			var element = root.getElementsByTagName("ip");
			var liveipvalue = element[0].firstChild.nodeValue;
			
			document.getElementById('LiveIPAddressPanel').label = liveipvalue;
		}
		else
		{
			alert(document.getElementById('liveipaddress-strings').getString("RequestProblem"));
		}
	}
}

function updateliveipaddress()
{
	makeRequest('http://www.showmyip.com/xml/', '');
	self.setTimeout('updateliveipaddress()', refreshEveryMilliSeconds);
}

window.addEventListener("load", updateliveipaddress, false);
